var IV_UserList;
var IV_MsgList;
var IV_RobotStatus = null;
var IV_RobotService = null;
var IV_SystemStatus;
var IV_RHPos = null;
var IV_ScenariState = 0;
var IV_VisitorFlag;
var IV_AnswerFlag;
var IV_MsgOld, IV_UserOld;
var IV_RHFinished = "False";
var IV_ShortCommand = "";

var IV_MsgUpdate = false;
var IV_UserListUpDate = false;

var PL_PageAjaxObj = null;

function ParseRoundMsg(msg)
{
	var orgStr, orgList, orgMax;
	var itemList;
	var itemWork;
	var cnt, itemCnt;
	/*
	 * メッセージの形式は以下の形式と仮定する。
	 * MsgData=メッセージデータ/hh:mm:ss(メッセージ登録時刻)/送信者/宛先/MsgID,メッセージデータ/hh:mm:ss(メッセージ登録時刻)/宛先.・・・
	 * RobotStatus=PA10/Waiting,RH/Running,・・・・
	 * SystemStatus=Normal/Waiting
	 * RHPos=10.5/30.9/70.0(X/Y/ω)
	 * Visitor=None
	 * Users=yotubata,tnninomi,・・・
	 *
	 * 各項目は「;(セミコロン)」で結合する。
	 */
	orgStr = msg;
	orgList = orgStr.split(";");
	orgMax = orgList.length;
	for(cnt = 0; cnt < orgMax; cnt++){
		itemList = orgList[cnt].split("=");
		switch(itemList[0]){
			case "MsgData":
				itemWork = itemList[1].split(",");
				if(itemList[1] != IV_MsgOld){
					IV_MsgOld = itemList[1];
					IV_MsgList = new Array(itemWork.length);
					for(itemCnt = 0; itemCnt < itemWork.length; itemCnt++){
						IV_MsgList[itemCnt] = itemWork[itemCnt].split("/");
					}
					// メッセージ最終時刻の記録？？
					// メッセージID方式は？
					IV_MsgUpdate = true;
				}
				else{
					//IV_MsgList = null;
					IV_MsgUpdate = false;
				}
				break;
			case "RobotStatus":
				itemWork = itemList[1].split(",");
				IV_RobotStatus = new Array(itemWork.length);
				for(itemCnt = 0; itemCnt < itemWork.length; itemCnt++){
					IV_RobotStatus[itemCnt] = itemWork[itemCnt].split("/");
				}
				break;
			case "SystemStatus":
				IV_SystemStatus = itemList[1].split("/");
				break;
			case "RHPos":
				IV_RHPos = itemList[1].split("/");
				break;
			case "Visitor":
				IV_VisitorFlag = itemList[1];
				break;
			case "Users":
				IV_UserOld = IV_UserList;
				IV_UserList = itemList[1].split(",");
				break;
			case "Answer":
				IV_AnswerFlag = itemList[1];
				break;
			case "RHMoveFinished":
				IV_RHFinished = itemList[1];
				break;
		}
	}
}

function IsMgsUpdate()
{
	return IV_MsgUpdate;
}

function IsUserListUpdate()
{
	return IV_UserListUpdate;
}

function GetVisitor()
{
	return IV_VisitorFlag;
}

function GetAnswer()
{
	return IV_AnswerFlag;
}

function GetUserList(index)
{
	if(index == null)	return IV_UserList;
	return IV_UserList[index];
}

function GetRH_Position(index)
{
	if(index == null)	return IV_RHPos;

	return IV_RHPos[index];
}

function GetSystemStatus()
{
	return IV_SystemStatus;
}

function GetRobotStatus(index)
{
	if(index == null){
		return IV_RobotStatus;
	}

	return IV_RobotStatus[index];
}

function GetRobotService(index)
{
	if(index == null){
		return IV_RobotService;
	}

	return IV_RobotService[index];
}

function GetMessageData(index)
{
	if(index == null)	return IV_MsgList;
	return IV_MsgList[index];
}

function GetRHState()
{
	return IV_RHFinished;
}

function GetScenarioState()
{
	return IV_ScenariState;
}
/////////////////////////////
//外部jsファイル依存機能  //
/////////////////////////////
var PL_TimeOutID;
var PL_TimeOutURL;
var PL_PollingTimeID;
var PL_CallbackFunc = null;
var IP_ipAddr = "";
var IV_List = "";
var IV_CandidateType = "";
var IV_CandidateIndex = -1;
var IV_SrvStage = -1;
var IV_VoiceRecState = 0;
var PL_Interrupt = false;
var IV_PollAjax;
var IV_IndicatorJpeg = "";
var IV_IndicatorText = "";
var IV_IndicateTimer = 0;
var IV_IndicateOn		= true;
var IV_CurrentIndicate	= 0;

function SetCandidateType(type)
{
	IV_CandidateIndex = -1;
	IV_ShortCommand = "";
	IV_CandidateType = type;
}

function CandidateClear()
{
//	alert("CandidateClear");
	IV_List = "";
	IV_CandidateType = "";
	IV_ShortCommand = "";
	IV_CandidateIndex = -1;

}

function ParseXMLMsg()
{
	if(XmlReq.responseXML != null){
		doc_root = XmlReq.responseXML.documentElement;
	}

	// 結果領域にデータを入れるが・・・XML文書をルートから全部見に行く
//	alert("XML Document found!");
	if((doc_root != null) && (typeof(doc_root) == "object")){
		IV_List = "";
		IV_CandidateIndex = -1;

		if(IV_RHPos == null)
			IV_RHPos		= new Array(3);
		if(IV_RobotStatus == null)
			IV_RobotStatus	= new Array(5);
		if(IV_RobotService == null)
			IV_RobotService	= new Array(5);

		IV_List = ParseNodes(doc_root);
	}
	/*
	else{
		alert("XMLが取得できませんでした。");
	}
	*/
}

// XMLノードを再帰的に見る関数
function ParseNodes(node_data)
{
	var nodes_cnt, child_nodes, cnt;
	var html_doc = "";

	// .firstChild 該当ノードの要素と言うかテキストデータ
/*
	if(node_data.firstChild != null){
		// テキストデータありなので、タグ名の横にテキストデータも表示
		html_doc = node_data.nodeName + " : " + node_data.firstChild.nodeValue;
	}
	else{
		// テキストデータ無いみたいだから、タグ名のみ表示
		html_doc = node_data.nodeName + " : ";
	}
*/
	// 子ノード群を取得
	child_nodes = node_data.childNodes;

	// 子ノードの数を取得
	nodes_cnt = child_nodes.length;

	switch(node_data.nodeName){
		case "Answer":
//			alert("Answer");
			IV_AnswerFlag = node_data.getAttribute("value");
			break;
		case "Camera":
//			alert("Camera : " + node_data.getAttribute("value"));
			IV_VisitorFlag = node_data.getAttribute("value");
			break;
		case "CandidateList":
//			alert("受信 " + node_data.getAttribute("type"));
			if(IV_CandidateType == node_data.getAttribute("type")){
//				alert("取得 " + IV_CandidateType);
				if(nodes_cnt > 0)
					html_doc = "<select name=\"candidateList\" id=\"candidateList\" multiple onChange=ListSelected()>";
				switch(node_data.getAttribute("type")){
				case "InsideName":
					break;
				case "OutsideName":
					break;
				case "OrgName":
					break;
				}
			}
			else{
//				alert("破棄 " + IV_CandidateType);
				return html_doc;
			}
			break;
		case "Candidate":
//			alert("Candidate");
			html_doc = "<option>" + node_data.getAttribute("text") + "</option>";
//			alert("Candidate : " + html_doc);
			break;
		case "CandidateSelect":
//			alert("Receive = " + parseInt(node_data.getAttribute("value")));
			IV_CandidateIndex = parseInt(node_data.getAttribute("value"));
			break;
		case "CandidateStage":
//			alert("CandidateStage");
			IV_SrvStage = parseInt(node_data.getAttribute("value"));
			break;
		case "VoiceRecognitionState":
			IV_VoiceRecState = parseInt(node_data.getAttribute("value"));
			break;
		case "RHMoveFinished":
			IV_RHFinished = node_data.getAttribute("value");
			break;
		case "ShortCommand":
			IV_ShortCommand = node_data.getAttribute("value");
			break;
		case "SystemStatus":
			IV_SystemStatus		= node_data.getAttribute("value");
			IV_RobotStatus[0]	= node_data.getAttribute("status");
			IV_RobotService[0]	= node_data.getAttribute("service");
			break;
		case "ScenarioStatus":
			IV_ScenariState = node_data.getAttribute("value");
			break;
		case "RHInfo":
			IV_RobotStatus[1]	= node_data.getAttribute("status");
			IV_RobotService[1]	= node_data.getAttribute("service");
			IV_RHPos[0] = node_data.getAttribute("X");
			IV_RHPos[1] = node_data.getAttribute("Y");
			IV_RHPos[2] = node_data.getAttribute("O");
			break;
		case "PA10Info":
			IV_RobotStatus[2]	= node_data.getAttribute("status");
			IV_RobotService[2]	= node_data.getAttribute("service");
			break;
		case "FrontDesk":
			IV_RobotStatus[3]	= node_data.getAttribute("status");
			IV_RobotService[3]	= node_data.getAttribute("service");
			break;
		case "Meeting":
			IV_RobotStatus[4]	= node_data.getAttribute("status");
			IV_RobotService[4]	= node_data.getAttribute("service");
			break;
	}

	// 子ノードが無い場合は処理終了
	if(nodes_cnt == 0)	return html_doc;

	// 子ノードの数分本関数を再帰呼び出しする
	for(cnt = 0; cnt < nodes_cnt; cnt++)
	{
		child_obj = child_nodes[cnt];
		if(child_obj.nodeType == 1){
			html_doc = html_doc + ParseNodes(child_obj);
		}
	}
	if(node_data.nodeName == "CandidateList"){
			html_doc = html_doc + "<option>0.該当なし</option></select>";
	}
//	alert(html_doc);
	return html_doc;
}


function PollingStart(callback, timeoutURL)
{
	IV_PollAjax = InitializeAjax(callback, null, null, null, null, null);
	IV_RHFinished = "False";
	PL_CallbackFunc = callback;
	PL_PollingTimeID = setTimeout("PollingRequestSend()", 500);

	if(timeoutURL != null){
		if(typeof(timeoutURL) == "string"){
			PL_TimeOutID	= setTimeout("TimeoutPageMove()", 30000);
			PL_TimeOutURL	= timeoutURL;
		}
		if(typeof(timeoutURL) == "function"){
			PL_TimeOutID	= setTimeout(timeoutURL, 30000);
		}
	}
	PL_PageAjaxObj = InitializeAjax(callback, null, null, null, null, null);
//	IV_IndicateTimer = setTimeout("ChangeIndicatorMark()", 1000);
	return PL_PageAjaxObj;
}

function TimeoutPageMove()
{
	clearTimeout(PL_TimeOutID);
	window.location.href = PL_TimeOutURL;
}

function PollingRequestSend()
{
//	alert("PollingRequestSend");
	clearTimeout(PL_PollingTimeID);
	if(IP_ipAddr != ""){
		SendAjaxRequest(IV_PollAjax, "/rtc/indata?get=1", PollingResult);
	}
	else{
		// IP取得が終了していない
		SendAjaxRequest(IV_PollAjax, "/cgi-bin/terminalServer.cgi?GetIP=1", GetIpResult);
	}
}

function PollingResult(ret_text, ret_xml, ret_stat)
{
// ポーリング結果処理
//alert("PollingResult");
//	ParseRoundMsg(ret_text);
	clearTimeout(PL_PollingTimeID);
	ParseXMLMsg();
	if(PL_CallbackFunc != null)
		PL_CallbackFunc(ret_text, ret_xml, ret_stat);

	if(PL_Interrupt == false)
		PL_PollingTimeID = setTimeout("PollingRequestSend()", 500);
	else{
		PL_Interrupt = false;
		PL_PollingTimeID = setTimeout("PollingResult()", 500);
	}
}
/*
function InterruptSendAjaxRequest(url)
{

	PL_Interrupt = true;
	SendAjaxRequest(IV_PollAjax, url, PollingResult);
}
*/

function SendAjaxRequestLocal(url, callback)
{
	SendAjaxRequest(PL_PageAjaxObj, url, callback);
}

function GetCandidateList()
{
//	IV_CandidateIndex = -1;
	return IV_List;
}

function GetCandidateIndex()
{
	return IV_CandidateIndex;
}

function GetServerStage()
{
	return IV_SrvStage;
}

function GetVoiceRecState()
{
	return IV_VoiceRecState;
}

function GetShortCommand()
{
	return IV_ShortCommand;
}

function GetIpAddr()
{
	return IP_ipAddr;
}

function GetIpResult(ret_text, ret_xml, ret_stat)
{
//	alert("GetIP");
	IP_ipAddr = ret_text;
	PL_PollingTimeID = setTimeout("PollingRequestSend()", 500);
}

function SetVoiceIndicator(indicate_type)
{
	if(indicate_type == null){
		indicate_type = GetVoiceRecState();
	}
	if(IV_CurrentIndicate == indicate_type)	return;
	IV_CurrentIndicate = indicate_type;
	switch(indicate_type){
	case 1:
		IV_IndicatorJpeg = "/image/VoiceReady.jpg";
		IV_IndicatorText = "準備中";
		break;
	case 2:
		IV_IndicatorJpeg = "/image/VoiceInput.jpg";
		IV_IndicatorText = "入力中";
		break;
	case 3:
		IV_IndicatorJpeg = "/image/Recognition.jpg";
		IV_IndicatorText = "認識中";
		break;
	case 4:
		IV_IndicatorJpeg = "/image/RecognitionEnd.jpg";
		IV_IndicatorText = "認識終了";
		break;
	case 5:
		IV_IndicatorJpeg = "/image/VoiceInputOK.jpg";
		IV_IndicatorText = "準備完了";
		break;
	default:
		IV_IndicatorJpeg = "";
		IV_IndicatorText = "";
		break;
	}
	if(IV_IndicatorJpeg.length > 0)
		window.VoiceIndicate.innerHTML = '<img src="' + IV_IndicatorJpeg + '" alt="' + IV_IndicatorText + '" width=64 heigh=64 />';
	else
		window.VoiceIndicate.innerHTML = '';
}

function ChangeIndicatorMark()
{
	clearTimeout(IV_IndicateTimer);
	IV_IndicateTimer = 0;
	if(document.getElementById("VoiceIndicate") != null){
		if(IV_IndicateOn){
			if(IV_CurrentIndicate == 0)		SetVoiceIndicator(GetVoiceRecState());
			IV_IndicateOn = false;

//			window.VoiceIndicate.innerHTML = '<div style="z-index: 2; position: absolute; top: 0px; left: 960px;" align="right">';
//			window.VoiceIndicate.innerHTML = window.VoiceIndicate.innerHTML + '<img src="' + IV_IndicatorJpeg + '" alt="' + IV_IndicatorText + '" width=64 heigh=64 />';
			window.VoiceIndicate.innerHTML = '<img src="' + IV_IndicatorJpeg + '" alt="' + IV_IndicatorText + '" width=64 heigh=64 />';
//			window.VoiceIndicate.innerHTML = window.VoiceIndicate.innerHTML + "</div>";
		}
		else{
			IV_IndicateOn = true;
			window.VoiceIndicate.innerHTML = "";
		}
		IV_IndicateTimer = setTimeout("ChangeIndicatorMark()", 1000);
	}
}
