function PollingProc()
{
	// ポーリングデータを捌く
	var termState;
	var serviceState;
	var rhPos;
	var	scenarioState;

	// 表示状態チェック
	if(typeof(TerminalStatus) != 'object')	return;

	// システム状態取得

	// 各PC状態取得
	/*
	termState = GetRobotStatus();
	TerminalStatus.rows[1].cells[1].innerText = termState[0];		// 制御端末
	TerminalStatus.rows[2].cells[1].innerText = termState[1];		// 受付端末
	TerminalStatus.rows[3].cells[1].innerText = termState[2];		// 会議室端末
	TerminalStatus.rows[4].cells[1].innerText = termState[3];		// RH
	TerminalStatus.rows[5].cells[1].innerText = termState[4];		// PA10

	// 各PCサービス実行状態取得
	serviceState = GetRobotService();
//	alert(serviceState[1]);
	TerminalStatus.rows[1].cells[2].innerText = serviceState[0];	// 制御端末
	TerminalStatus.rows[2].cells[2].innerText = serviceState[1];	// 受付端末
	TerminalStatus.rows[3].cells[2].innerText = serviceState[2];	// 会議室端末
	TerminalStatus.rows[4].cells[2].innerText = serviceState[3];	// RH
	TerminalStatus.rows[5].cells[2].innerText = serviceState[4];	// PA10
	*/
	TerminalStatus.rows[1].cells[1].innerText = GetRobotStatus(0);	// 制御端末
	TerminalStatus.rows[2].cells[1].innerText = GetRobotStatus(1);	// 受付端末
	TerminalStatus.rows[3].cells[1].innerText = GetRobotStatus(2);	// 会議室端末
	TerminalStatus.rows[4].cells[1].innerText = GetRobotStatus(3);	// RH
	TerminalStatus.rows[5].cells[1].innerText = GetRobotStatus(4);	// PA10

	TerminalStatus.rows[1].cells[2].innerText = GetRobotService(0);	// 制御端末
	TerminalStatus.rows[2].cells[2].innerText = GetRobotService(1);	// 受付端末
	TerminalStatus.rows[3].cells[2].innerText = GetRobotService(2);	// 会議室端末
	TerminalStatus.rows[4].cells[2].innerText = GetRobotService(3);	// RH
	TerminalStatus.rows[5].cells[2].innerText = GetRobotService(4);	// PA10

	// RH位置情報取得
	rhPos = GetRH_Position();
	window.RH_Cursor.style.left	= rhPos[0] + "px";
	window.RH_Cursor.style.top	= rhPos[1] + "px";

	// シナリオ実行状態取得
	scenarioState = GetScenarioState();
	switch(scenarioState){
		case "0":		// 未実行
			window.ScenarioStatus.innerText = "シナリオは実行されていません。";
			break;
		case "1":		// 実行中
			window.ScenarioStatus.innerHTML = "<input type=button value = '一時停止' onClick='ScenarioControl(2)'/>&emsp;&emsp;&emsp;<input type=button value = '破棄する' onClick='ScenarioControl(0)'/>";
			break;
		case "2":		// 一時停止中
			window.ScenarioStatus.innerHTML = "<input type=button value = '停止解除' onClick='ScenarioControl(1)'/>&emsp;&emsp;&emsp;<input type=button value = '破棄する' onClick='ScenarioControl(0)'/>";
			break;
	}
}

function ScenarioControl(CtrlID)
{
	SendAjaxRequestLocal("/rtc/outdata?Command=ScenarioControl&Value=" + CtrlID);
}
