#ifndef SYSTEMCONTROL_H_
#define SYSTEMCONTROL_H_

#include "QueryInfo.h"
#include "CGI_Engine.h"
#include "UserMemberData.h"
#include "TextData.h"

#define SEM_LOCK_SYSCONTROL			SEM_LOCK_ID + 14

class SystemControl : public CGI_Engine{
public:
	SystemControl(QueryInfo *query);
	~SystemControl();

protected:
	std::string	getHTMLFileName(std::string pageName, std::string command);
	std::string	getMapData(std::string keyName);
	bool		readDataFile();
	bool		loopProc(std::string loopKey);

private:
	std::map <std::string, std::string> curData;
	TextDataFile	textData;
	std::string		folderKey;
	std::string		dataFile;
};

#endif /*SYSTEMCONTROL_H_*/
