/*
 * Ajax用グローバル変数定義
 */
var XmlReq		= null;
//var ajaxTimerID = 0;
var callbackFunc200	= func200;
var callbackFunc401	= func401;
var callbackFunc403	= func403;
var callbackFunc404	= func404;
var callbackFunc408	= func408;
var callbackFunc500	= func500;


/*
 * Ajax用オブジェクト作成
 */
function InitializeAjax(callback200, callback401, callback403, callback404, callback408, callback500){
	var	ret_val;
	//callbackFunc200 = callback200;

	if(callback200 != undefined)		callbackFunc200	= callback200;
	if(callback401 != undefined)		callbackFunc401	= callback401;
	if(callback403 != undefined)		callbackFunc403	= callback403;
	if(callback404 != undefined)		callbackFunc404	= callback404;
	if(callback408 != undefined)		callbackFunc408	= callback408;
	if(callback500 != undefined)		callbackFunc500	= callback500;

	if(window.XMLHttpRequest){
		// IE以外
		ret_val = new XMLHttpRequest();
	}
	else{
		if(window.ActiveXObject){
			// IEの場合
			ret_val = new ActiveXObject("Microsoft.XMLHTTP");
		}
	}
	if(window.ActiveXObject){
		// IEの場合・・・なぜか()を付けてはいけない
		ret_val.onreadystatechange = GetAjaxResult;
	}
	else{
		// IE以外・・・普通だよね
		ret_val.onreadystatechange = function(){GetAjaxResult(callback200, ret_val)};
	}

	if(XmlReq == null)
		XmlReq = ret_val;

	return ret_val;
}

function SendAjaxRequest(AjaxObj, url, callback)
{
//	clearTimeout(ajaxTimerID);
/*
	if(!XmlReq){
		alert("InitializeAjaxが呼ばれていません。しばらく待ってから再度実行してください。");
		return -1;
	}
*/
	if(!AjaxObj){
		alert("InitializeAjaxが呼ばれていません。しばらく待ってから再度実行してください。");
		return -1;
	}

	AjaxObj.open('GET', url);
	AjaxObj.send(null);
	/*
	if(callback == undefined)
		AjaxObj.onreadystatechange = GetAjaxResult();
	else
		AjaxObj.onreadystatechange = callback;
	*/
	AjaxObj.onreadystatechange = function(){GetAjaxResult(callback, AjaxObj)};

	sleep(500);
	return 0;
}

function GetAjaxResult(another_callback, AjaxObj)
{
//	clearTimeout(ajaxTimerID);
	// 返信データ受信完了でステータス200の場合、正常にデータを受信した
	if(AjaxObj.readyState == 4){
		switch(AjaxObj.status){
			case 200:
				// 正常時処理
//				alert("200");
				if(another_callback == undefined){
//					alert("callbackFunc200");
					callbackFunc200(AjaxObj.responseText, AjaxObj.responseXML, AjaxObj.status);
				}
				else{
//					alert("another_callback");
					another_callback(AjaxObj.responseText, AjaxObj.responseXML, AjaxObj.status);
				}
				break;
			case 401:
//				alert("401");
				callbackFunc401();
				break;
			case 403:
//				alert("403");
				callbackFunc403();
				break;
			case 404:
//				alert("404");
				callbackFunc404();
				break;
			case 408:
//				alert("408");
				callbackFunc408();
				break;
			case 500:
//				alert("500");
				callbackFunc500();
				break;
		}
	}
	/*
	else{
		ajaxTimerID = setTimeout("GetAjaxResult()", 500);
	}
	*/
}

function func200()
{
	//callbackFunc200(null, null, 200);
}
function func401()
{
	callbackFunc200(null, null, 401);
}
function func403()
{
	callbackFunc200(null, null, 403);
}
function func404()
{
	callbackFunc200(null, null, 404);
}
function func408()
{
	callbackFunc200(null, null, 408);
}
function func500()
{
	callbackFunc200(null, null, 500);
}
